*** histograms.in	2012-08-13 16:44:29.000000000 +0100
--- histograms.f90	2012-08-13 15:23:46.000000000 +0100
***************
*** 677,690 ****
  !-----------------------------------------------------------------------
  
!       SUBROUTINE mrqmin(x,y,sig,ndata,a,ia,ma,covar,alpha,nca,chisq,
!      *funcs,alamda)
!       INTEGER ma,nca,ndata,ia(ma),MMAX
!       DOUBLE PRECISION alamda,chisq,funcs,a(ma),alpha(nca,nca),covar(nca,nca),
!      *sig(ndata),x(ndata),y(ndata)
!       PARAMETER (MMAX=20)
! CU    USES covsrt,gaussj,mrqcof
!       INTEGER j,k,l,mfit
        DOUBLE PRECISION ochisq,atry(MMAX),beta(MMAX),da(MMAX)
        SAVE ochisq,atry,beta,da,mfit
        if(alamda.lt.0.d0)then
          mfit=0
--- 677,693 ----
  !-----------------------------------------------------------------------
  
!       SUBROUTINE mrqmin(x,y,sig,ndata,a,ia,ma,covar,alpha,nca,chisq,     &
!           funcs,alamda)
! !  Copyright (C) 1986, 1992 Numerical Recipes Software
!       INTEGER :: ma,nca,ndata,ia(ma)
!       DOUBLE PRECISION :: alamda, chisq, a(ma), alpha(nca,nca),             &
!           covar(nca,nca), sig(ndata), x(ndata), y(ndata)
!       EXTERNAL funcs
!       INTEGER, PARAMETER :: MMAX=48
! !U    USES covsrt,gaussj,mrqcof
!       INTEGER j,k,l,m,mfit
        DOUBLE PRECISION ochisq,atry(MMAX),beta(MMAX),da(MMAX)
        SAVE ochisq,atry,beta,da,mfit
+ 
        if(alamda.lt.0.d0)then
          mfit=0
***************
*** 699,713 ****
  12      continue
        endif
!       do 14 j=1,mfit
!         do 13 k=1,mfit
!           covar(j,k)=alpha(j,k)
! 13      continue
!         covar(j,j)=alpha(j,j)*(1.d0+alamda)
!         da(j)=beta(j)
  14    continue
        call gaussj(covar,mfit,nca,da,1,1)
        if(alamda.eq.0.d0)then
          call covsrt(covar,nca,ma,ia,mfit)
-         call covsrt(alpha,nca,ma,ia,mfit)
          return
        endif
--- 702,723 ----
  12      continue
        endif
!       j=0
!       do 14 l=1,ma
!         if(ia(l).ne.0) then
!           j=j+1
!           k=0
!           do 13 m=1,ma
!             if(ia(m).ne.0) then
!               k=k+1
!               covar(j,k)=alpha(j,k)
!             endif
! 13        continue
!           covar(j,j)=alpha(j,j)*(1.d0+alamda)
!           da(j)=beta(j)
!         endif
  14    continue
        call gaussj(covar,mfit,nca,da,1,1)
        if(alamda.eq.0.d0)then
          call covsrt(covar,nca,ma,ia,mfit)
          return
        endif
***************
*** 723,750 ****
          alamda=0.1d0*alamda
          ochisq=chisq
!         do 17 j=1,mfit
!           do 16 k=1,mfit
!             alpha(j,k)=covar(j,k)
! 16        continue
!           beta(j)=da(j)
  17      continue
-         do 18 l=1,ma
-           a(l)=atry(l)
- 18      continue
        else
          alamda=10.d0*alamda
          chisq=ochisq
        endif
!       return
!       END
!       SUBROUTINE mrqcof(x,y,sig,ndata,a,ia,ma,alpha,beta,nalp,chisq,
!      *funcs)
!       INTEGER ma,nalp,ndata,ia(ma),MMAX
!       DOUBLE PRECISION chisq,a(ma),alpha(nalp,nalp),beta(ma),sig(ndata),x(ndata),
!      *y(ndata)
        EXTERNAL funcs
!       PARAMETER (MMAX=20)
!       INTEGER mfit,i,j,k,l,m
!       DOUBLE PRECISION dy,sig2i,wt,ymod,dyda(MMAX)
        mfit=0
        do 11 j=1,ma
--- 733,771 ----
          alamda=0.1d0*alamda
          ochisq=chisq
!         j=0
!         do 17 l=1,ma
!           if(ia(l).ne.0) then
!             j=j+1
!             k=0
!             do 16 m=1,ma
!               if(ia(m).ne.0) then
!                 k=k+1
!                 alpha(j,k)=covar(j,k)
!               endif
! 16          continue
!             beta(j)=da(j)
!             a(l)=atry(l)
!           endif
  17      continue
        else
          alamda=10.d0*alamda
          chisq=ochisq
        endif
! 
!       END SUBROUTINE mrqmin
! 
! !-----------------------------------------------------------------------
! 
!       SUBROUTINE mrqcof(x,y,sig,ndata,a,ia,ma,alpha,beta,nalp,chisq,     &
!           funcs)
! !  Copyright (C) 1986, 1992 Numerical Recipes Software
!       INTEGER :: ma,nalp,ndata,ia(ma)
!       DOUBLE PRECISION :: chisq,a(ma), alpha(nalp,nalp), beta(ma),      &
!       sig(ndata), x(ndata), y(ndata)
        EXTERNAL funcs
!       INTEGER, PARAMETER :: MMAX=48
!       INTEGER :: mfit,i,j,k,l,m
!       DOUBLE PRECISION :: dy,sig2i,wt,ymod,dyda(MMAX)
! 
        mfit=0
        do 11 j=1,ma
***************
*** 784,794 ****
  17      continue
  18    continue
!       return
!       END
        SUBROUTINE covsrt(covar,npc,ma,ia,mfit)
!       INTEGER ma,mfit,npc,ia(ma)
!       DOUBLE PRECISION covar(npc,npc)
!       INTEGER i,j,k
!       DOUBLE PRECISION swap
        do 12 i=mfit+1,ma
          do 11 j=1,i
--- 805,819 ----
  17      continue
  18    continue
! 
!       END SUBROUTINE mrqcof
! 
! !-----------------------------------------------------------------------
! 
        SUBROUTINE covsrt(covar,npc,ma,ia,mfit)
! !  Copyright (C) 1986, 1992 Numerical Recipes Software
!       INTEGER :: ma,mfit,npc,ia(ma)
!       DOUBLE PRECISION :: covar(npc,npc)
!       INTEGER :: i,j,k
!       DOUBLE PRECISION :: swap
        do 12 i=mfit+1,ma
          do 11 j=1,i
***************
*** 813,824 ****
          endif
  15    continue
!       return
!       END
        SUBROUTINE gaussj(a,n,np,b,m,mp)
!       INTEGER m,mp,n,np,NMAX
!       DOUBLE PRECISION a(np,np),b(np,mp)
!       PARAMETER (NMAX=50)
!       INTEGER i,icol,irow,j,k,l,ll,indxc(NMAX),indxr(NMAX),ipiv(NMAX)
!       DOUBLE PRECISION big,dum,pivinv
        do 11 j=1,n
          ipiv(j)=0
--- 838,853 ----
          endif
  15    continue
! 
!       END SUBROUTINE covsrt
! 
! !-----------------------------------------------------------------------
! 
        SUBROUTINE gaussj(a,n,np,b,m,mp)
! !  Copyright (C) 1986, 1992 Numerical Recipes Software
!       INTEGER :: m,mp,n,np
!       DOUBLE PRECISION :: a(np,np),b(np,mp)
!       INTEGER, PARAMETER :: NMAX=50
!       INTEGER :: i,icol,irow,j,k,l,ll,indxc(NMAX),indxr(NMAX),ipiv(NMAX)
!       DOUBLE PRECISION :: big,dum,pivinv
        do 11 j=1,n
          ipiv(j)=0
***************
*** 854,858 ****
          indxr(i)=irow
          indxc(i)=icol
!         if (a(icol,icol).eq.0.d0) pause 'singular matrix in gaussj'
          pivinv=1.d0/a(icol,icol)
          a(icol,icol)=1.d0
--- 883,888 ----
          indxr(i)=irow
          indxc(i)=icol
!         if (a(icol,icol).eq.0.d0)                                       &
!             call die('singular matrix in gaussj',.false.)
          pivinv=1.d0/a(icol,icol)
          a(icol,icol)=1.d0
***************
*** 885,895 ****
          endif
  24    continue
!       return
!       END
        SUBROUTINE fgauss(x,a,y,dyda,na)
!       INTEGER na
!       DOUBLE PRECISION x,y,a(na),dyda(na)
!       INTEGER i
!       DOUBLE PRECISION arg,ex,fac
        y=0.d0
        do 11 i=1,na-1,3
--- 915,930 ----
          endif
  24    continue
! 
!       END SUBROUTINE gaussj
! 
! !-----------------------------------------------------------------------
! 
        SUBROUTINE fgauss(x,a,y,dyda,na)
! !  Copyright (C) 1986, 1992 Numerical Recipes Software
!       INTEGER :: na
!       DOUBLE PRECISION :: x,y,a(na),dyda(na)
!       INTEGER :: i
!       DOUBLE PRECISION :: arg,ex,fac
! 
        y=0.d0
        do 11 i=1,na-1,3
***************
*** 902,907 ****
          dyda(i+2)=fac*arg/a(i+2)
  11    continue
!       return
!       END
  
        END MODULE histograms
--- 937,943 ----
          dyda(i+2)=fac*arg/a(i+2)
  11    continue
! 
!       END SUBROUTINE fgauss
  
        END MODULE histograms
+ 
